Helipad = "unLoaded";
Flag = "unLoaded";
Icon = "unLoaded";
--IconType = "RiotGuardIcon";
--HeliType = "Riot_Helicopter";
--Global var located here and in Helipad. If changed, changed both.
PairDistance = 10;
Delay = 10; -- The Delay between Spawned helicopter leaving the map and another avalible
function Create()
    Set("HelipadID","None");
    Set("HeliID","None");
    Set("FlagID","None");
    Set("IconID","None");
    Set("HeliStatus","None");
    Set("Spawn", false);
    Set("Tooltip","tooltip_heliControl_Info");
    Set("Version","v2.0");
    --Custom Settings to be set by Addon mod
    Set("IconType","None");
    Set("HeliType","None");
    Set("Min",0);
    Set("Max",0);
end

function Update(timePassed)
    --Save against Corruption
    if Get("Version") ~= "v2.0" then
        Object.Delete(this);
    end
-------------------------------------------------------------------------------------------
-- Load References
-------------------------------------------------------------------------------------------
    Flag = Load(Flag,"HeliFlag","FlagID",1000000);   
    Helipad = Load(Helipad,"Helipad","HelipadID",PairDistance);
    Icon = Load(Icon,Get("IconType"),"IconID",2);
    if Get("IconID") == "None" then
        Icon = Object.Spawn(Get("IconType"),this.Pos.x-0.02,this.Pos.y-1.1);
        if Icon ~= nil then
            Set("IconID",Icon.Id.i);
        end
    end
    -- Find a Helipad else Set/Get info on Helipad
    if Get("HelipadID") == "None" then
        objs = Object.GetNearbyObjects("Helipad",PairDistance);
        for o , d in pairs(objs) do
            if Get("HelipadID") == "None" then
                Helipad = o;
                Set("HelipadID",Helipad.Id.i);
            end
        end
    else
    --Check to see Helipad has been deleted.
        if GetObject("Helipad",Get("HelipadID"),PairDistance) == nil then
            Set("HelipadID","None");
            Helipad = "unLoaded";
        end
    end
        Print(Get("IconType","None"));
        Print(Get("HeliType","None"));
        Print(Get("Min",0));
        Print(Get("Max",0));
-------------------------------------------------------------------------------------------
-- Spawn Flag and Helipad
-------------------------------------------------------------------------------------------      
    if Get("Spawn") then                
        --Conditions to Spawn the helicopter
        if GetFrom(Helipad,"InUse") == false and tonumber(GetFrom(Helipad,"Delay")) <= 0 then
            --Spawn a flag for Helicopter to spawn on.
                Flag = Object.Spawn("HeliFlag",0,GetFrom(Helipad,"Pos.y"));
                Set("FlagID",Flag.Id.i);
                SetOn(Helipad,"InUse",true);
        end
        --Wait until Flag has reached edge of map.
        if Get("FlagID") ~= "None" and Get("HeliID") == "None" then
            if GetFrom(Flag,"ReachedEdge") == true then
                local flagX = GetFrom(Flag,"Pos.x");
                local flagY = GetFrom(Flag,"Pos.y");        
                --Create Heli, Store ID and Destination.
                Heli = Object.Spawn("Custom_Helicopter",flagX,flagY);
                Print(Heli);
                SetOn(Heli,"HeliType",Get("HeliType"));
                SetOn(Heli,"Min",Get("Min"));
                SetOn(Heli,"Max",Get("Max"));
                Set("HeliID",Heli.Id.i);
                SetOn(Heli,"HelipadID",Helipad.Id.i);
                SetOn(Heli,"FlagID",Flag.Id.i);
                SetOn(Heli,"ControlID",this.Id.i);
                SetOn(Heli,"Destination","Helipad");
                Set("Tooltip","tooltip_heliControl_OnRoute");
            end
        end
    end
-------------------------------------------------------------------------------------------
-- Check if activated
-------------------------------------------------------------------------------------------
    -- If we have a referenced Helipad then check for guards nearby.
    if Helipad ~= "unLoaded" and GetFrom(Helipad,"InUse") == false then
        if not Get("Spawn") then
            objs = Object.GetNearbyObjects("Guard",0.1);
            if len(objs) > 0 then
                Set("Spawn", true);
                -- Send all checked guards to the Helipad.
                for o, d in pairs(objs) do
                    o.PlayerOrderPos.x = Helipad.Pos.x+2;
                    o.PlayerOrderPos.y = Helipad.Pos.y+2;
                end
            end
        end       
    end
-------------------------------------------------------------------------------------------
-- Helicopter Status Response
-------------------------------------------------------------------------------------------
    -- HeliStatus is set by the helicopter.
    if Get("HeliID") ~= "None" then
        if Get("HeliStatus") == "Arrived" then
            Set("Tooltip","tooltip_heliControl_OnRoute");
        elseif Get("HeliStatus") == "Waiting" then
            Set("Tooltip","tooltip_heliControl_Waiting");
        elseif Get("HeliStatus") == "Fueling" then
            Set("Tooltip","tooltip_heliControl_Fueling");
        elseif Get("HeliStatus") == "Leaving" then
            Set("Tooltip","tooltip_heliControl_Leaving");
        elseif Get("HeliStatus") == "LeftMap" then            
            Set("HeliID","None");
            Set("HeliStatus","None")
            Set("Spawn",false);
            if Get("HelipadID") ~= "None" then
                SetOn(Helipad,"Delay",Delay);
                SetOn(Helipad,"InUse",false);
            end
            Set("FlagID","None");
        end
    elseif Get("HeliID") == "None" then
        if Get("HelipadID") ~= "None" then
            if GetFrom(Helipad,"InUse") == false then
                Set("Tooltip","tooltip_heliControl_Info");
            else
                Set("Tooltip","tooltip_heliControl_InUse");
            end
        else
            Set("Tooltip","tooltip_heliControl_Cancled");
            Set("Spawn",false);
        end
    end
    SetOn(Icon,"Tooltip",Get("Tooltip"));
-------------------------------------------------------------------------------------------
-- Keep the flag Alive while Helicopter is on map
-------------------------------------------------------------------------------------------
    if Get("FlagID") ~= "None" then
        SetOn(Flag,"life",0.0);
    end
    if Get("IconID") ~= "None" then
        SetOn(Icon,"life",0.0);
    end
end
















    --Helper Functions
function Set(name, value)
    Object.SetProperty(name, value);
end
function Get(name)
    return Object.GetProperty(name);
end
function GetN(name)
    return tonumber(Object.GetProperty(name));
end
function GetFrom(ident, name)
    return Object.GetProperty(ident, name);
end
function SetOn(ident, name, value)
    return Object.SetProperty(ident, name, value);
end
function Print(text)
    Game.DebugOut("Cat", text);
end
function PrintProperty(name)
    local property = Get(name);
    if property == nil then
        property = "nil";
    end    
    
    Print(name .. ": " .. tostring(property));
end
function PropStr(prop)
    return " " .. prop .. ": " .. tostring(Get(prop));
end--]]


-- get the length of a table
function len(tab)
	local count = 0
	for _ in pairs(tab) do
		count = count + 1
	end
	return count
end
--Return Object if in range.
function GetObject(type,id,dist)
	objs = Object.GetNearbyObjects(type,dist or 1)
	for o,d in pairs(objs) do
		 if o.Id.i == id then
		 	return o
		 end
	end
end
--Find Object after Load.
function Load(Object, Type, ID, dist)
    if Object == "unLoaded" then
        Print(tostring("Trying to load "..Type.." with ID: "..ID));
        TempID = Get(tostring(ID));
        Object = GetObject(Type,TempID,dist);
        Print("Found: "..Type.." Table: "..tostring(Object).." ID: "..TempID);
    end
    return Object;
end