function Create()
    Set("HeliStatus","None");
    Set("InUse",false);
    Set("Delay",0);
    Set("Version","v2.0");
    Set("FuelStocked",0);
end

function Update(timePassed)
    --Save against Corruption
    if Get("Version") ~= "v2.0" then
        Object.Delete(this);
    end
    if Get("InUse") == false then
        Set("Tooltip","");
        if tonumber(Get("Delay")) > 0 then
            Set("Tooltip","Maintenance in progress\nTime until finished: "..tostring(math.ceil(Get("Delay"))));
            Object.CreateJob("Helipad_Maintenance");
            if CheckNearby("Workman",2) >= 1 then
                Set("Delay",tonumber(Get("Delay"))-timePassed);
            end
        else
            Set("Tooltip","tooltip_helipad_MaintenanceComplete");
        end
    else
        Set("Tooltip","");
    end
end

function JobComplete_Helipad_Maintenance()
end


function CheckNearby(entity,dist)
    Count = Object.GetNearbyObjects(entity,dist);
    return len(Count);
end









































    --Helper Functions
function Set(name, value)
    Object.SetProperty(name, value);
end
function Get(name)
    return Object.GetProperty(name);
end
function GetN(name)
    return tonumber(Object.GetProperty(name));
end
function GetFrom(ident, name)
    return Object.GetProperty(ident, name);
end
function SetOn(ident, name, value)
    return Object.SetProperty(ident, name, value);
end
function Print(text)
    Game.DebugOut("Cat", text);
end
function PrintProperty(name)
    local property = Get(name);
    if property == nil then
        property = "nil";
    end    
    
    Print(name .. ": " .. tostring(property));
end
function PropStr(prop)
    return " " .. prop .. ": " .. tostring(Get(prop));
end
-- get the length of a table
function len(tab)
	local count = 0
	for _ in pairs(tab) do
		count = count + 1
	end
	return count
end
--Return Object if in range.
function GetObject(type,id,dist)
	objs = Object.GetNearbyObjects(type,dist or 1)
	for o,d in pairs(objs) do
		 if o.Id.i == id then
		 	return o
		 end
	end
end
--Find Object after Load.
function Load(Object, Type, ID, dist)
    if Object == "" then
        Print(tostring("Trying to load "..Type.." with ID: "..ID));
        TempID = Get(tostring(ID));
        Object = GetObject(Type,TempID,dist);
        Print("Found: "..Type.." Table: "..tostring(Object).." ID: "..TempID);
    end
    return Object;
end