local oldX = 0.0;
local posX = 0.0;
local newX = 0.0;
local reachedEdge;

function Create()
    Set("ReachedEdge", false);
    Set("Wait", 5.0);
    Set("life", 0.0);
    Set("Version","v2.0");
end

function Update(timePassed)
    --Save against Corruption
    if Get("Version") ~= "v2.0" then
        Object.Delete(this);
    end
-------------------------------------------------------------------------------------------
-- This flag will be deleted if its Controler is removed.
-------------------------------------------------------------------------------------------
    if tonumber(Get("life")) >= 10 then
        Object.Delete(this);
    else
        Set("life", tonumber(Get("life")) + timePassed);
    end
-------------------------------------------------------------------------------------------
-- Find Edge of map
-------------------------------------------------------------------------------------------    
    --Try to keep moving if not at edge
    if Get("ReachedEdge") == false then
        oldX = posX;
        posX = Get("Pos.x");
        Set("Pos.x",posX - 1);
        
        local newX = 1+Get("Pos.x");
        
        local intX = math.floor(oldX);
        local finX = math.floor(newX);
        
        --check if at edge
        if intX == finX then
            Set("ReachedEdge", true);
        end
    else
        --At edge so will wait
        local waitTime = tonumber(Get("Wait"));
        if waitTime <= 0.0 then
            Set("ReachedEdge", false);
            waitTime = 5.0
        end        
        Set("Wait", waitTime - timePassed);
    end
    local ReachedEdge = tostring(Get("ReachedEdge"));
    local Wait = tostring(Get("Wait")); 
end
































































    --Helper Functions
function Set(name, value)
    Object.SetProperty(name, value);
end
function Get(name)
    return Object.GetProperty(name);
end
function GetN(name)
    return tonumber(Object.GetProperty(name));
end
function GetFrom(ident, name)
    return Object.GetProperty(ident, name);
end
function SetOn(ident, name, value)
    return Object.SetProperty(ident, name, value);
end
function Print(text)
    Game.DebugOut("Cat", text);
end
function PrintProperty(name)
    local property = Get(name);
    if property == nil then
        property = "nil";
    end    
    
    Print(name .. ": " .. tostring(property));
end
function PropStr(prop)
    return " " .. prop .. ": " .. tostring(Get(prop));
end--]]


-- get the length of a table
function len(tab)
	local count = 0
	for _ in pairs(tab) do
		count = count + 1
	end
	return count
end
--Return Object if in range.
function GetObject(type,id,dist)
	objs = Object.GetNearbyObjects(type,dist or 1)
	for o,d in pairs(objs) do
		 if o.Id.i == id then
		 	return o
		 end
	end
end
--Find Object after Load.
function Load(Object, Type, ID, dist)
    if Object == "" then
        Print(tostring("Trying to load "..Type.." with ID: "..ID));
        TempID = Get(tostring(ID));
        Object = GetObject(Type,TempID,dist);
        Print("Found: "..Type.." Table: "..tostring(Object).." ID: "..TempID);
    end
    return Object;
end